!Report Test Framework by Carl Barnes from https://gist.github.com/CarlTBarnes  https://git.io/JtP6r
!-----------------------------------------------------------------------------
!Try various REPORT specs and PROP Settings quicky in this little Win32 project that has its own simple Previewer.
!If you want to report a bug this can be used to create a small example
!
!1. Create a new Win32 Project and paste this code.
!2. Add the Variables used on the REPORT  - at #2 below
!3. Add Your REPORT and DETAIL's          - at #3 below
!4. Add your PRINT() code and PROP code   - at #4 below
!5. Run and Test, adjust code, repeat
!-----------------------------------------------------------------------------
  PROGRAM !Report Test Framework by Carl Barnes
  INCLUDE('PRNPROP.CLW') 
  MAP
      DB(STRING DebugText)  !Debug Output
      DBClear()             !Empty debug buffer
      MODULE('WinAPI')
        OutputDebugString(*cstring Msg),PASCAL,RAW,DLL(1),NAME('OutputDebugStringA')
      END    
    END 

    !--The Stuff needed for Preview
PreviewQ  QUEUE,PRE(PreQ)
FileName    STRING(260)
    END

    !#2. >>>--Define your test data
String1 STRING('string1 string1')
String2 STRING('string2 string2')

    !#3. >>>--Define your Report
Report REPORT,AT(1000,2000,6000,7000),FONT('Arial',10),PRE(RPT),THOUS
        HEADER,AT(1000,1000,6000,1000),USE(?HEADER1)
            STRING('Report Test Prop Font changes'),AT(208,94),USE(?Title),TRN,FONT(,,,FONT:bold)
        END
Detail1 DETAIL,AT(0,0,6000,1146),USE(?Detail1)
            STRING('What Test'),AT(167,10,,146),USE(?WhatTest),TRN,FONT(,8)
            STRING(@s40),AT(167,292),USE(String1)
            STRING(@s40),AT(2990,292,2729),USE(String2)
            STRING('These changed to Times 16 by PROP'),AT(2990,10,1229,146),USE(?Fyi),TRN,FONT(,8)
            STRING('I am Original in Arial 10'),AT(167,615),USE(?PropTestOrig)
            STRING('Prop Font changed to Times 16?'),AT(2990,615,2729),USE(?PropTestChange)
            LINE,AT(177,958,5490,0),USE(?LINE1)
        END
        FOOTER,AT(1000,9000,6000,1000),USE(?unnamed)
        END
        FORM,AT(1000,1000,6000,9000),USE(?FORM1)
        END
    END

TestHow BYTE 
    CODE             

    !--Create Report
    OPEN(Report)
    REPORT{PROP:Preview}=PreviewQ       
    Report$?Title{PROP:Text}=Report$?Title{PROP:Text} &' - Build ' & System{PROP:LibVersion,3} 

    !#4. >>>--Add your code to produce the report

       Report$?WhatTest{PROP:Text}='Test #1 with Report$?FEQ{{PROP}' !Works
       Report$?String2{PROP:Right}=1                !works
       Report$?String2{PROP:FontSize}=16            !fails
       Report$?String2{PROP:FontName}='Times New Roman'  !fails
       Report$?String2{PROP:FontStyle}=FONT:Bold + FONT:italic  !fails
       Report$?PropTestChange{PROP:FontSize}=16
       Report$?PropTestChange{PROP:FontName}='Times New Roman' 
       PRINT(Rpt:Detail1)

       SETTARGET(Report)    !works
       ?WhatTest{PROP:Text}='Test #2 SetTarget(Report) ; ?FEQ{{PROP}'
       ?String2{PROP:Center}=1                       !Try Center, works
       ?String2{PROP:FontSize}=16
       ?String2{PROP:FontName}='Times New Roman'
       ?String2{PROP:FontStyle}=FONT:Regular + FONT:italic
       ?PropTestChange{PROP:FontSize}=16
       ?PropTestChange{PROP:FontName}='Times New Roman'
       SETTARGET()
       PRINT(Rpt:Detail1)

    !--Report done, prepare it for preview
    ENDPAGE(Report)
    ! CLOSE(Report) loses files

    !--Preview the report
    DO ReportPreviewRtn
    CLOSE(Report)


!-----------------  Open Preview Window and display --------------------------
ReportPreviewRtn    ROUTINE     
    DATA
PrintIt     Bool
PreviewWindow WINDOW('Preview'),AT(,,495,332),FONT('Microsoft Sans Serif',8,,FONT:regular),SYSTEM,MAX,RESIZE,CENTER 
       LIST,AT(1,2,317,11),USE(?List:PreviewQ),VSCROLL,FONT(,10,,),DROP(10),FROM(PreviewQ)
       BUTTON('&Print'),AT(332,1,41,11),USE(?PrintBtn)
       IMAGE,AT(1,15),USE(?Image1),FULL,HVSCROLL
     END
    CODE
    
    OPEN(PreviewWindow)
    ?List:PreviewQ{PROP:Selected}=1
    ?PrintBtn{PROP:Tip} = 'Print to ' & printer{PROPPRINT:Device}
    ACCEPT
        IF ACCEPTED()=?List:PreviewQ OR EVENT()=Event:OpenWindow
           GET(PreviewQ,CHOICE(?List:PreviewQ))
           ?Image1{PROP:Text}=PreviewQ
           DISPLAY
        ELSIF ACCEPTED() = ?PrintBtn
            PrintIt=True
            BREAK
        END
    END
    CLOSE(PreviewWindow)
    IF PrintIt THEN REPORT{PROP:FlushPreview}=True.
    exit

!----------------------------------------
DB   PROCEDURE(STRING xMessage)
Prfx EQUATE('RptTest: ')   !All output gets this
sz   CSTRING(SIZE(Prfx)+SIZE(xMessage)+3),AUTO
  CODE
  sz  = Prfx & CLIP(xMessage) & '<13,10>'
  OutputDebugString( sz )
  RETURN
DBClear PROCEDURE()
DVClr CSTRING('DBGVIEWCLEAR') !Message to Clear the buffer. Must UPPER and first i.e. without a Prefix
  CODE
  OutputDebugString(DVClr)
  RETURN